<html>
<head>
    <title>Awesomesauce</title>
    <script src="jquery-1.11.2.min.js"></script>
    <script>

function dump(obj) {
    var out = '';
    for (var i in obj) {
        out += i + ": " + obj[i] + "\n";
    }

    alert(out);
}

function outputPrinterRow(service)
{
    out = "<td><a href='http://" + service.ip + ":" + service.port + "/'>" + service.data.name + "</a></td>";
    out += "<td>" + service.name + "</td>";
    out += "<td>" + service.realname + "</td>";
    out += "<td>" + service.ip + "</td>";
    out += "<td>" + service.data.firmware_version + "</td>";
    out += "<td>" + service.data.hotend_type_0 + "</td>";
    out += "<td>" + service.data.hotend_type_1 + "</td>";
    out += "<td>" + service.data.hotend_serial_0 + "</td>";
    out += "<td>" + service.data.hotend_serial_1 + "</td>";
    out += "<td>" + service.data.hotend_time_hot_0 + "</td>";
    out += "<td>" + service.data.hotend_time_hot_1 + "</td>";
    out += "<tr><td colspan='11'><a href='http://"+service.ip+":8080/?action=stream'><img src='http://" + service.ip + ":8080/?action=snapshot' width='50%'></a></td></tr>";
    return out;
}

$(document).ready(function()
{
    $.getJSON('service_list.php', function(data)
    {
        var out = "<table border=1>";
        out += "<tr><th>Name<th>hostname<th>Printer name<th>ip<th>version<th>Hotend 1<th>Hotend 2<th>Hotend 1 serial<th>Hotend 2 serial<th>Hotend 1 Time Hot (days)<th>Hotend 2 Time Hot (days)";

        for(var idx in data)
        {
            var service = data[idx];
            if (service.data.type != 'printer')
                continue;
            if (!service.data.firmware_version)
                service.data.firmware_version = service.data.version
            if (!service.data.hotend_serial_0)
                service.data.hotend_serial_0 = "-"
            if (!service.data.hotend_serial_1)
                service.data.hotend_serial_1 = "-"
            if (!service.data.hotend_type_0)
                service.data.hotend_type_0 = "-"
            if (!service.data.hotend_type_1)
                service.data.hotend_type_1 = "-"
            if (!service.data.hotend_time_hot_0)
                service.data.hotend_time_hot_0 = "-"
            if (!service.data.hotend_time_hot_1)
                service.data.hotend_time_hot_1 = "-"

            if (service.name.slice(0, 23) == "ultimakersystem-ccbdd30")
            {
                var jedi_number = parseInt(service.name.slice(23), 16);
                if (jedi_number < 256)
                    service.realname = "Jedi-" + parseInt(service.name.slice(23), 16);
                else
                    service.realname = "?";
            }else{
                service.realname = "???";
            }
        }

        data.sort(function(a, b)
        {
            if (a.realname < b.realname)
                return -1;
            if (a.realname > b.realname)
                return 1;
            return 0;
        });

        for(var idx in data)
        {
            out += "<tr>";
            out += outputPrinterRow(data[idx]);
            out += "</tr>";
        }
        out += "</table>";
        $("#main").html(out);
    });
});
    </script>
</head>
<body>
<div id="main">Searching for printers...</div>
</body>
</html>
